#!/usr/bin/python
# -*- coding: utf-8 -*-

"""
TODO: docstring
"""

__version__ = '$Id: run_game_debug.py 383 2011-04-02 07:03:36Z dr0iddr0id@gmail.com $'

import sys
import os
import subprocess


# run in right directory
if not sys.argv[0]:
    appdir = os.path.abspath(os.path.dirname(__file__))
else:
    appdir = os.path.abspath(os.path.dirname(sys.argv[0]))
os.chdir(appdir)
# make sure that sub modules in gamelib are imported corectly
appdir = os.path.join(appdir, 'gamelib')
if not appdir in sys.path:
    sys.path.insert(0, appdir)

import main

def load(filename):
    import hotshot.log
    from hotshot.log import ENTER, EXIT, LINE
    log = hotshot.log.LogReader(filename)
    db = {}
    accum = 0
    for event in log:
        what, (filename, lineno, funcname), tdelta = event
        if tdelta > 0:
            accum += tdelta
        if what == LINE:
            try:
                db[(filename, lineno, funcname)].append(tdelta * 0.0000001)
            except:
                db[(filename, lineno, funcname)] = [tdelta * 0.0000001]
        elif what == ENTER:
            try:
                db[(filename, lineno, funcname)].append(accum * 0.0000001)
            except:
                db[(filename, lineno, funcname)] = [accum * 0.0000001]
            accum = 0
        elif what == EXIT:
            try:
                db[(filename, lineno, funcname)].append(accum * 0.0000001)
            except:
                db[(filename, lineno, funcname)] = [accum * 0.0000001]
            accum = 0
    return db

def print_data(db, count=80, sorted_by=None):
    # Print the top line timings
    print('\n', '-'*70)
    if sorted_by:
        print('sorte by', sorted_by)
    print("%10s %10s %-20s  %5s  %s" % ('call count', 'total time', 'func', 'filename', 'lineno'))
    print('')
    for i in range(min(count, len(db))):
        tottime, callcount, (filename, lineno, funcname) = db[i]
#        filename = os.path.basename(filename)
        print("%10i %010f %-20s  %5s  %s" % (callcount, tottime, funcname, filename, lineno))

def run_debug():
    # running in debug mode
    #sys.argv.append('-profile')
    if "-profile" in sys.argv:
        import cProfile
        import pstats

        profile_data_fname = "t.profile" #tempfile.mktemp("prf")
        try:
            cProfile.run('main.main()', profile_data_fname, sort=1)
            stats = pstats.Stats(profile_data_fname)
            stats.strip_dirs().sort_stats('time').print_stats()
        finally:
            pass
    else:
        main.main()


if __name__ == '__main__':
    run_debug()
